using LAview, Core, GObject.Plugins;

extern const string GETTEXT_PACKAGE;

/**
 * Plugin of type A1.
 */
public class PluginObjectExample : PluginObject {

	/**
	 * Constructs a new ``PluginObjectExample``.
	 */
	construct {
		stdout.puts ("PluginObjectExample init () called\n");
	}

	/**
	 * Destroys the ``PluginProtocolExample``.
	 */
	~PluginObjectExample () {
		stdout.puts ("PluginObjectExample deinit () called\n");
	}

	/**
	 * Gets a name of the plugin.
	 */
	public override string get_name () {
		return "ProtObjEx";
	}

	/**
	 * Gets readable name of the plugin.
	 */
	public override string get_readable_name () {
		stdout.puts ("PluginObjectExample.get_readable_name () called\n");
		stdout.puts ("Call IHostCore.any_host_method () from PluginObjectExample:\n  ");
		(host as IHostCore).any_host_method ();
		return _("Protocol Object Example");
	}
}

[ModuleInit]
Type plugin_init (GLib.TypeModule type_module) {
	return typeof (PluginObjectExample);
}
